diff --git a/arch/arm/lib/board.c b/arch/arm/lib/board.c
index 0521178..2b46529 100644
--- a/arch/arm/lib/board.c
+++ b/arch/arm/lib/board.c
@@ -153,13 +153,13 @@ static int display_dram_config(void)
 		print_size(gd->bd->bi_dram[i].size, "\n");
 	}
 #else
-	ulong size = 0;
+	/*ulong size = 0;
 
 	for (i = 0; i < CONFIG_NR_DRAM_BANKS; i++)
 		size += gd->bd->bi_dram[i].size;
 
 	puts("DRAM:  ");
-	print_size(size, "\n");
+	print_size(size, "\n");*/
 #endif
 
 	return (0);
@@ -168,10 +168,10 @@ static int display_dram_config(void)
 #if defined(CONFIG_HARD_I2C) || defined(CONFIG_SOFT_I2C)
 static int init_func_i2c(void)
 {
-	puts("I2C:   ");
+	/*puts("I2C:   ");
 	i2c_init(CONFIG_SYS_I2C_SPEED, CONFIG_SYS_I2C_SLAVE);
 	puts("ready\n");
-	return (0);
+	return (0);*/
 }
 #endif
 
@@ -525,14 +525,14 @@ void board_init_r(gd_t *id, ulong dest_addr)
 #endif
 
 	gd->flags |= GD_FLG_RELOC;	/* tell others: relocation done */
-	bootstage_mark_name(BOOTSTAGE_ID_START_UBOOT_R, "board_init_r");
+	//bootstage_mark_name(BOOTSTAGE_ID_START_UBOOT_R, "board_init_r");
 
 	monitor_flash_len = _end_ofs;
 
 	/* Enable caches */
-	enable_caches();
+	//enable_caches();
 
-	debug("monitor flash len: %08lX\n", monitor_flash_len);
+	//debug("monitor flash len: %08lX\n", monitor_flash_len);
 	board_init();	/* Setup chipselects */
 	/*
 	 * TODO: printing of the clock inforamtion of the board is now
@@ -591,16 +591,16 @@ void board_init_r(gd_t *id, ulong dest_addr)
 #endif
 
 #if defined(CONFIG_CMD_NAND)
-	puts("NAND:  ");
-	nand_init();		/* go init the NAND */
+	//puts("NAND:  ");
+	//nand_init();		/* go init the NAND */
 #endif
 
 #if defined(CONFIG_CMD_ONENAND)
-	onenand_init();
+	//onenand_init();
 #endif
 
 #ifdef CONFIG_GENERIC_MMC
-	puts("MMC:   ");
+	//puts("MMC:   ");
 	mmc_initialize(gd->bd);
 #endif
 
@@ -610,25 +610,25 @@ void board_init_r(gd_t *id, ulong dest_addr)
 #endif
 
 	/* initialize environment */
-	if (should_load_env())
+	//if (should_load_env())
 		env_relocate();
-	else
-		set_default_env(NULL);
+	//else
+	//	set_default_env(NULL);
 
 #if defined(CONFIG_CMD_PCI) || defined(CONFIG_PCI)
 	arm_pci_init();
 #endif
 
-	stdio_init();	/* get the devices list going. */
+	//stdio_init();	/* get the devices list going. */
 
-	jumptable_init();
+	//jumptable_init();
 
 #if defined(CONFIG_API)
 	/* Initialize API */
 	api_init();
 #endif
 
-	console_init_r();	/* fully init console as a device */
+	//console_init_r();	/* fully init console as a device */
 
 #ifdef CONFIG_DISPLAY_BOARDINFO_LATE
 # ifdef CONFIG_OF_CONTROL
@@ -641,7 +641,7 @@ void board_init_r(gd_t *id, ulong dest_addr)
 
 #if defined(CONFIG_ARCH_MISC_INIT)
 	/* miscellaneous arch dependent initialisations */
-	arch_misc_init();
+	//arch_misc_init();
 #endif
 #if defined(CONFIG_MISC_INIT_R)
 	/* miscellaneous platform dependent initialisations */
@@ -664,8 +664,8 @@ void board_init_r(gd_t *id, ulong dest_addr)
 	bb_miiphy_init();
 #endif
 #if defined(CONFIG_CMD_NET)
-	puts("Net:   ");
-	eth_initialize(gd->bd);
+	//puts("Net:   ");
+	//eth_initialize(gd->bd);
 #if defined(CONFIG_RESET_PHY_R)
 	debug("Reset Ethernet PHY\n");
 	reset_phy();
diff --git a/board/ti/am335x/board.c b/board/ti/am335x/board.c
index c92e1e9..99322f1 100644
--- a/board/ti/am335x/board.c
+++ b/board/ti/am335x/board.c
@@ -90,6 +90,10 @@ int board_is_evm_15_or_later(void)
  */
 static int read_eeprom(void)
 {
+	//header.magic = 0xEE3355AA;
+	//strcpy(header.name, "A335BNLT");
+	//return 0;
+
 	/* Check if baseboard eeprom is available */
 	if (i2c_probe(CONFIG_SYS_I2C_EEPROM_ADDR)) {
 		puts("Could not probe the EEPROM; something fundamentally "
@@ -363,6 +367,7 @@ void s_init(void)
 	/* Initalize the board header */
 	enable_i2c0_pin_mux();
 	i2c_init(CONFIG_SYS_I2C_SPEED, CONFIG_SYS_I2C_SLAVE);
+	//puts("**** Need to take care of this!\n");
 	if (read_eeprom() < 0)
 		puts("Could not get board ID.\n");
 
diff --git a/common/cmd_bootm.c b/common/cmd_bootm.c
index 7438469..040fef2 100644
--- a/common/cmd_bootm.c
+++ b/common/cmd_bootm.c
@@ -777,13 +777,13 @@ static image_header_t *image_get_kernel(ulong img_addr, int verify)
 	image_print_contents(hdr);
 
 	if (verify) {
-		puts("   Verifying Checksum ... ");
-		if (!image_check_dcrc(hdr)) {
-			printf("Bad Data CRC\n");
-			bootstage_error(BOOTSTAGE_ID_CHECK_CHECKSUM);
-			return NULL;
-		}
-		puts("OK\n");
+		puts("   Verifying Checksum ... Skipped!\n");
+		//if (!image_check_dcrc(hdr)) {
+		//	printf("Bad Data CRC\n");
+		//	bootstage_error(BOOTSTAGE_ID_CHECK_CHECKSUM);
+		//	return NULL;
+		//}
+		//puts("OK\n");
 	}
 	bootstage_mark(BOOTSTAGE_ID_CHECK_ARCH);
 
@@ -1151,12 +1151,12 @@ static int image_info(ulong addr)
 
 		image_print_contents(hdr);
 
-		puts("   Verifying Checksum ... ");
-		if (!image_check_dcrc(hdr)) {
-			puts("   Bad Data CRC\n");
-			return 1;
-		}
-		puts("OK\n");
+		puts("   Verifying Checksum ... Skipped!\n");
+		//if (!image_check_dcrc(hdr)) {
+		//	puts("   Bad Data CRC\n");
+		//	return 1;
+		//}
+		//puts("OK\n");
 		return 0;
 #if defined(CONFIG_FIT)
 	case IMAGE_FORMAT_FIT:
@@ -1224,12 +1224,12 @@ static int do_imls_nor(void)
 				printf("Legacy Image at %08lX:\n", (ulong)hdr);
 				image_print_contents(hdr);
 
-				puts("   Verifying Checksum ... ");
-				if (!image_check_dcrc(hdr)) {
-					puts("Bad Data CRC\n");
-				} else {
-					puts("OK\n");
-				}
+				puts("   Verifying Checksum ... Skipped!\n");
+				//if (!image_check_dcrc(hdr)) {
+				//	puts("Bad Data CRC\n");
+				//} else {
+				//	puts("OK\n");
+				//}
 				break;
 #if defined(CONFIG_FIT)
 			case IMAGE_FORMAT_FIT:
@@ -1283,11 +1283,11 @@ static int nand_imls_legacyimage(nand_info_t *nand, int nand_dev, loff_t off,
 			nand_dev, off);
 	image_print_contents(imgdata);
 
-	puts("   Verifying Checksum ... ");
-	if (!image_check_dcrc(imgdata))
-		puts("Bad Data CRC\n");
-	else
-		puts("OK\n");
+	puts("   Verifying Checksum ... Skipped!\n");
+	//if (!image_check_dcrc(imgdata))
+	//	puts("Bad Data CRC\n");
+	//else
+	//	puts("OK\n");
 
 	free(imgdata);
 
diff --git a/drivers/mmc/omap_hsmmc.c b/drivers/mmc/omap_hsmmc.c
index 166744c..40e44a5 100644
--- a/drivers/mmc/omap_hsmmc.c
+++ b/drivers/mmc/omap_hsmmc.c
@@ -303,6 +303,8 @@ static void mmc_reset_controller_fsm(struct hsmmc *mmc_base, u32 bit)
 static int mmc_send_cmd(struct mmc *mmc, struct mmc_cmd *cmd,
 			struct mmc_data *data)
 {
+	//return 0;
+
 	struct hsmmc *mmc_base;
 	unsigned int flags, mmc_stat;
 	ulong start;
@@ -383,7 +385,7 @@ static int mmc_send_cmd(struct mmc *mmc, struct mmc_cmd *cmd,
 	start = get_timer(0);
 	do {
 		mmc_stat = readl(&mmc_base->stat);
-		if (get_timer(0) - start > MAX_RETRY_MS) {
+		if (get_timer(0) - start > (MAX_RETRY_MS - 990)) {
 			printf("%s : timeout: No status update\n", __func__);
 			return TIMEOUT;
 		}
diff --git a/drivers/usb/musb-new/musb_core.c b/drivers/usb/musb-new/musb_core.c
index da93571..14855d1 100644
--- a/drivers/usb/musb-new/musb_core.c
+++ b/drivers/usb/musb-new/musb_core.c
@@ -1408,6 +1408,8 @@ enum { MUSB_CONTROLLER_MHDRC, MUSB_CONTROLLER_HDRC, };
  */
 static int __devinit musb_core_init(u16 musb_type, struct musb *musb)
 {
+	return 0;
+
 	u8 reg;
 	char *type;
 	char aInfo[90], aRevision[32], aDate[12];
diff --git a/include/configs/am335x_evm.h b/include/configs/am335x_evm.h
index 04eaa8b..26a5ede 100644
--- a/include/configs/am335x_evm.h
+++ b/include/configs/am335x_evm.h
@@ -49,7 +49,7 @@
 #define CONFIG_VERSION_VARIABLE
 
 /* set to negative value for no autoboot */
-#define CONFIG_BOOTDELAY		1
+#define CONFIG_BOOTDELAY		0
 #define CONFIG_ENV_VARS_UBOOT_CONFIG
 #define CONFIG_ENV_VARS_UBOOT_RUNTIME_CONFIG
 #ifndef CONFIG_SPL_BUILD
@@ -63,7 +63,7 @@
 	"bootfile=uImage\0" \
 	"fdtfile=am335x-boneblack.dtb\0" \
 	"console=ttyO0,115200n8\0" \
-	"optargs=\0" \
+	"optargs=quiet\0" \
 	"mtdids=" MTDIDS_DEFAULT "\0" \
 	"mtdparts=" MTDPARTS_DEFAULT "\0" \
 	"dfu_alt_info_mmc=" DFU_ALT_INFO_MMC "\0" \
@@ -105,7 +105,7 @@
 		"root=/dev/nfs " \
 		"nfsroot=${serverip}:${rootpath},${nfsopts} rw " \
 		"ip=dhcp\0" \
-	"bootenv=uEnv.txt\0" \
+	"bootenv=\0" \
 	"loadbootenv=load mmc ${mmcdev} ${loadaddr} ${bootenv}\0" \
 	"importbootenv=echo Importing environment from mmc ...; " \
 		"env import -t $loadaddr $filesize\0" \